Bug 823843 - cifs: Fix oplock break handling
cifs: Fix oplock break handling
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: kernel (Show other bugs)
6.4
All Linux
unspecified Severity medium
: rc
: ---
Assigned To: Sachin Prabhu
Jian Li
:
Depends On:
Blocks: 798385
  Show dependency treegraph
 
Reported: 2012-05-22 05:59 EDT by Sachin Prabhu
Modified: 2014-03-03 19:08 EST (History)
5 users (show)

See Also:
Fixed In Version: kernel-2.6.32-298.el6
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-02-21 00:56:48 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Sachin Prabhu 2012-05-22 05:59:56 EDT
Backport of the following upstream patch
--
commit 12fed00de963433128b5366a21a55808fab2f756
Author: Pavel Shilovsky <piastryyy@gmail.com>
Date:   Mon Jan 17 20:15:44 2011 +0300

CIFS: Fix oplock break handling (try #2)

When we get oplock break notification we should set the appropriate
value of OplockLevel field in oplock break acknowledge according to
the oplock level held by the client in this time. As we only can have
level II oplock or no oplock in the case of oplock break, we should be
aware only about clientCanCacheRead field in cifsInodeInfo structure.

Also fix bug connected with wrong interpretation of OplockLevel field
during oplock break notification processing.

Signed-off-by: Pavel Shilovsky <piastryyy@gmail.com>
Cc: <stable@kernel.org>
Signed-off-by: Steve French <sfrench@us.ibm.com>
--
Comment 2 RHEL Product and Program Management 2012-07-27 12:21:11 EDT
This request was evaluated by Red Hat Product Management for
inclusion in a Red Hat Enterprise Linux release.  Product
Management has requested further review of this request by
Red Hat Engineering, for potential inclusion in a Red Hat
Enterprise Linux release for currently deployed products.
This request is not yet committed for inclusion in a release.
Comment 3 Jian Li 2012-08-01 02:00:23 EDT
according to patch, oplock breaking test are needed (and data cache).
Comment 4 Jarod Wilson 2012-08-16 17:22:13 EDT
Patch(es) available on kernel-2.6.32-298.el6
Comment 7 Jian Li 2013-02-01 11:29:32 EST
This bug is verified 2.6.32-356.el6.i686, reproduced on 2.6.32-296.el6.i686. 

Two clients, the 1st one open the shared file with 'r+' mode, it get exclusive lock.  after then, the 2nd one open the shared file with 'r' mode, server send 'oplock break notify' to 1st client.

1st mount: mount.cifs //server/cifs /mnt/test -o password=xxxx
2nd mount: mount.cifs //server/cifs /mnt/test -o cache=null,passowrd=xxxx

Reproducer, message from dmesg when open cifsFYI(7):
#dmesg
** snip **
fs/cifs/misc.c: Checking for oplock break or dnotify response
fs/cifs/misc.c: oplock type 0x2 level 0x1
fs/cifs/misc.c: file id match, oplock break
fs/cifs/misc.c: Exclusive Oplock granted on inode f2d9d070
fs/cifs/file.c: Oplock flush inode f2d9d070 rc 0

and after the 2nd one open file (cache=null), 1st client write data to file, the 2nd client couldn't got the latested data.


Verifer:

[root@hp-xw4600-01 ~]# dmesg
**snip**
fs/cifs/connect.c: rfc1002 length 0x37
fs/cifs/misc.c: Checking for oplock break or dnotify response
fs/cifs/misc.c: oplock type 0x2 level 0x1
fs/cifs/misc.c: file id match, oplock break
fs/cifs/misc.c: Level II Oplock granted on inode f5a15070
fs/cifs/file.c: Oplock flush inode f5a15070 rc 0
fs/cifs/cifssmb.c: CIFSSMBLock timeout 0 numLock 0
fs/cifs/transport.c: For smb_command 36
fs/cifs/transport.c: Sending smb:  total_len 55
fs/cifs/misc.c: Null buffer passed to cifs_small_buf_release
fs/cifs/file.c: Oplock release rc = 0

and there is not data cache problem
Comment 9 errata-xmlrpc 2013-02-21 00:56:48 EST
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

http://rhn.redhat.com/errata/RHSA-2013-0496.html

Note You need to log in before you can comment on or make changes to this bug.